package com.fp.persistence.pgeneral.schedule;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENSCHEDULEPARAMETERS*/
@Entity(name="TgeneScheduleParameters")
@Table(name="TGENSCHEDULEPARAMETERS")
public class TgeneScheduleParameters extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneScheduleParameters
*/
@Id
@Column(name="COMPANYCODE" ,nullable=false, updatable=false)
private Integer pk;
@Column(name="OFFICECODE", nullable=true)

/**
* Codigo de oficina
*/
private Integer officecode;

@Column(name="BRANCHCODE", nullable=true)

/**
* Codigo de sucursal
*/
private Integer branchcode;

@Column(name="USERCODE", nullable=true)

/**
* Codigo de usuario
*/
private String usercode;

@Column(name="CHANNELCODE", nullable=true)

/**
* Codigo de canal.
*/
private String channelcode;

@Column(name="TERMINALCODE", nullable=true)

/**
* Codigo de terminal
*/
private String terminalcode;

@Column(name="AREACODE", nullable=true)

/**
* Codigo de area
*/
private Integer areacode;

/**Contructor por defecto*/
public TgeneScheduleParameters(){
}
/**Contructor de TgeneScheduleParameters
@param pPk Clave Primaria del entity
*/
public TgeneScheduleParameters(Integer pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneScheduleParameters
*/
public static TgeneScheduleParameters find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneScheduleParameters obj = pEntityManager.find(TgeneScheduleParameters.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneScheduleParameters
@return El objeto que referencia a la Clave primaria de TgeneScheduleParameters
*/
public Integer getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneScheduleParameters
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneScheduleParameters
*/
public void setPk(Integer pPk){
  pk=pPk;
}
/**Obtiene el valor de officecode
@return valor de officecode*/
public Integer getOfficecode(){
  return officecode;
}
/**Fija el valor de officecode
@param pOfficecode nuevo Valor de officecode*/
public void setOfficecode(Integer pOfficecode){
  officecode=pOfficecode;
}

/**Obtiene el valor de branchcode
@return valor de branchcode*/
public Integer getBranchcode(){
  return branchcode;
}
/**Fija el valor de branchcode
@param pBranchcode nuevo Valor de branchcode*/
public void setBranchcode(Integer pBranchcode){
  branchcode=pBranchcode;
}

/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de channelcode
@return valor de channelcode*/
public String getChannelcode(){
  return channelcode;
}
/**Fija el valor de channelcode
@param pChannelcode nuevo Valor de channelcode*/
public void setChannelcode(String pChannelcode){
  channelcode=pChannelcode;
}

/**Obtiene el valor de terminalcode
@return valor de terminalcode*/
public String getTerminalcode(){
  return terminalcode;
}
/**Fija el valor de terminalcode
@param pTerminalcode nuevo Valor de terminalcode*/
public void setTerminalcode(String pTerminalcode){
  terminalcode=pTerminalcode;
}

/**Obtiene el valor de areacode
@return valor de areacode*/
public Integer getAreacode(){
  return areacode;
}
/**Fija el valor de areacode
@param pAreacode nuevo Valor de areacode*/
public void setAreacode(Integer pAreacode){
  areacode=pAreacode;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneScheduleParameters))return false;
    TgeneScheduleParameters that = (TgeneScheduleParameters) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneScheduleParameters
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneScheduleParameters
*/
public Object createInstance(){
 TgeneScheduleParameters instance=new TgeneScheduleParameters();	
 return instance;
}
/**Clona la entidad TgeneScheduleParameters
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneScheduleParameters p=(TgeneScheduleParameters)this.clone();
  return p;
}
}
